var jsp = {};
jsp.views = {};

/**
 * Manage the transition between pages
 */
(function() {
	"use strict";

	function getDuneapi() {
		var api = jsp.byId("duneapi");
		if (!api || !api.getUserSetting) {
			api = {
				getUserSetting: function() {},
				setUserSetting: function() {},
				setPlaybackEventCallback: function() {},
				play: function() {},
				setColorKey: function() {}
			};
		}
		return api;
	}

	function init() {
		jsp.duneapi = getDuneapi();
		jsp.api.loadData({
			callbackSuccess: function() {
				jsp.view.init();
				jsp.api.imagePreload();
			},
			callbackError: function() {
				jsp.byId("main").innerHTML = "<div class='error'>Communication error. Please check the internet connection and restart application.</div>";
			}
		});
	}

	function exitPlugin() {
		jsp.duneapi.exitBrowser(jsp.duneapi.EXIT_BROWSER_MODE_CLOSE);
	}

	function reload() {
		location.reload(true);
	}

	function keyListener(e) {
		var code = e.keyCode,
			exitKey = jsp.keyCode[jsp.api.getExitPluginKey()];

		e.preventDefault();

		switch (code) {
			case exitKey:
				exitPlugin();
				break;
			case jsp.keyCode.dune:
				reload();
				break;
		}
	}

	window.addEventListener("load", init);
	window.addEventListener("keydown", keyListener);


})();
